#pragma once

#include <systypes/base.h>

#include "page_mapper.h"
#include "resource.h"



/* A pager exposing a dataspace. */

class Pager : public Resource
{
protected:
    offset_t _start, _size;
    PageMapper *_mapper;
    flags_t _flags;

public:
    explicit Pager(PageMapper *mapper, flags_t flags);

    virtual void close();

    /* Paging methods. */

    virtual long map(offset_t offset, l4_addr_t hot_spot, flags_t flags,
                     l4_snd_fpage_t *region);

    /* Limit methods. */

    offset_t get_data_size();

    /* File methods. */

    virtual long flush(offset_t populated_size, offset_t *size);

    virtual long resize(offset_t *size);

    /* Mapped file methods. */

    virtual long mmap(offset_t position, offset_t length, offset_t *start_pos,
                      offset_t *end_pos, offset_t *size);
};

// vim: tabstop=4 expandtab shiftwidth=4
